unit FileFind;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type TMatchEvent = procedure(Sender:TObject; const SearchRec:TSearchRec; var Accept:boolean) of Object;

TFileAttributes = set of (ftReadOnly, ftHidden, ftSysFile, ftVolumeID, ftDirectory, ftArchive);

  TFileFinder = class(TComponent)
  private
    { Private declarations }
    FFileSpec:string;
    FOnMatch: TMatchEvent;
    FSearchRec:TSearchRec;
    FFileAttributes:TFileAttributes;
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
  { Published declarations }
    property FileSpec:string read FFileSpec write FFileSpec;
    property OnMatch : TMatchEvent read FOnMatch write FOnMatch;
    property FileAttributes:TFileAttributes read FFileAttributes write FFileAttributes;
    function Search:integer;
  end;


procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TFileFinder]);
end;


function TFileFinder.Search: integer;
{seach for matching files:
- Returns number found
- See OnMatch event to catch each file found}
var
    Found : integer;
    Accept :boolean;
    Attribs : integer;
begin
     Result := 0;
     Accept := false;

     Attribs := 0;
     if ftHidden in FFileAttributes then Attribs := Attribs+faHidden;
     if ftSysFile in FFileAttributes then Attribs := Attribs+faSysFile;
     if ftArchive in FFileAttributes then Attribs := Attribs+faArchive;
     if ftVolumeID in FFileAttributes then Attribs := Attribs+faVolumeID;
     if ftDirectory in FFileAttributes then Attribs := Attribs+faDirectory;
     if ftReadOnly in FFileAttributes then Attribs := Attribs+faReadOnly;
    try
       Found := FindFirst(FFileSpec, Attribs, FSearchRec);
       while Found = 0 do
       begin
            Inc(Result);
            if assigned(FOnMatch) then FOnMatch(Self, FSearchRec, Accept);
            if Accept then Exit;
            Found := FindNext(FSearchRec);
       end;
    finally
       FindClose(FSearchRec);
    end;
end;


constructor TFileFinder.Create(AOwner: TComponent);
var
   FileAttributes:integer;
begin
  inherited Create(AOwner);
//  FFileAttributes := [faReadOnly, faHidden, faSysFile, faVolumeID, faDirectory, faArchive];
end;

destructor TFileFinder.Destroy;
begin
  inherited Destroy;
end;

end.
